package rocks.zipcode.io.quiz4.collections;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

/**
 * @author leon on 11/12/2018.
 */
public class SimpleStringGroup implements Iterable, Collection {
    private String string;
    private String valueToInsert;
    private int indexOfValue;


    public SimpleStringGroup(String string, String valueToInsert, int indexOfValue) {
        this.string = string;
        this.valueToInsert = valueToInsert;
        this.indexOfValue = indexOfValue;
    }

    List<String> list = new ArrayList<>();
    SimpleStringGroup group = new SimpleStringGroup();

    public SimpleStringGroup() {
        throw new UnsupportedOperationException("Method not yet implemented");
    }

    public Integer count() {
        return size();
    }

    public void insert(String string) {
        list.add(string);
    }

    public Boolean has(String valueToInsert) {
       if(list.contains(valueToInsert)){
            return true;
        }
        return false;
    }

    public String fetch(int indexOfValue) {
      return String.valueOf(list.contains(indexOfValue));

    }

    public void delete(String valueToInsert) {
        group.delete(valueToInsert);
    }

    @Override
    public int size() {
        return size();
    }

    @Override
    public boolean isEmpty() {

      return list.isEmpty();
    }

    @Override
    public boolean contains(Object o) {
        if(list.equals(o)){
            return true;
        }
        return false;
    }

    @Override
    public Object[] toArray() {
        return new Object[0];
    }

    @Override
    public boolean add(Object o) {

        return true;
    }

    @Override
    public boolean remove(Object o) {
        return group.remove(o);
    }

    @Override
    public boolean addAll(Collection c) {
        return group.addAll(c);
    }

    @Override
    public boolean retainAll(Collection c) {
        return group.retainAll(c);
    }

    @Override
    public boolean removeAll(Collection c) {
        return group.removeAll(c);
    }

    @Override
    public boolean containsAll(Collection c) {
        return group.containsAll(c);
    }

    @Override
    public Object[] toArray(Object[] a) {
        return new Object[0];
    }

    public void clear() {
        if (string.equals(valueToInsert)){
            clear();
        }

    }

    @Override
    public String toString() {
        return "SimpleStringGroup{" +
                "string='" + string + '\'' +
                ", valueToInsert='" + valueToInsert + '\'' +
                ", indexOfValue=" + indexOfValue +
                '}';
    }

    @Override
    public Iterator iterator() {
        return null;
    }


}
